-- 藏品柜详情信息
checkRequire("Lua_CollectionDetailPanel");
Lua_CollectionDetailWindow = class("Lua_CollectionDetailWindow", Lua_Window);
function Lua_CollectionDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionDetailWindow";
	self.skinName = "CollectionDetailWindow_skin";
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_CollectionDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isShowBtn = true;
	self.startPosY = self.winBg.posY;
	self.containerStartPosY = 93;

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(-121, 192, 0);
	
	self.detailPanel = Lua_CollectionDetailPanel.new(self.content);
	self.detailPanel:setRectPivot(1);
	self.detailPanel:setLocation(0, self.containerStartPosY);

	self.rewardBg:addClickFuntion(self, self.onBtnClick);
	self.shareBtn:addClickFuntion(self, self.onShareClick);

	self:addLuaEvent("UPDATE_COLLECTION_CABINET_INFO", self, self.updateShowInfo);
end

function Lua_CollectionDetailWindow:showWin(param)
	self:superCall("showWin", param);

	-- 只有在藏品柜查看才有分享和领取奖励
	-- 道具tips只有介绍
	-- 聊天场景查看多个成长属性或附加属性描述
	local collectVo;
	if type(param) == "table" then -- 聊天场景和道具tips
		self.isShowBtn = false;
		if param.isShowInfo == nil then -- 其他人
			self.isOther = true;
			collectVo = Lua_ToolVo.createToolVo(param.collection_item_id);
			collectVo:fromServer(param);
		else -- 自己或道具tips
			collectVo = DataCenter.collectionData:getCollectionVo(param.id);
			if collectVo == nil then -- 功能没开启
				collectVo = Lua_ToolVo.createToolVo(param.id);
			end
		end
	elseif type(param) == "number" then -- 查看
		collectVo = DataCenter.collectionData:getCollectionVo(param);
	end

	if collectVo == nil then self:hide(); end
	self:showDetailInfo(collectVo);
end

function Lua_CollectionDetailWindow:updateShowInfo(isRefrsh)
	if self.isOther then
		return; -- 其他人不刷新界面
	end
	self:showDetailInfo(self.showCollectVo);
end

function Lua_CollectionDetailWindow:showDetailInfo(showVo)
	self.showCollectVo = showVo;
	-- print(self.showData, self.showCollectVo, showVo);

	if showVo.is_have == 0 then
		local targetValue = getConfig(showVo.target_value[1], showVo.target_value[2], showVo.target_value[3]);
		local progressValue = showVo.obtain_progress;
		if progressValue >= targetValue then
			self.shareBtn:setLangValue(460017);
		else
			self.shareBtn:setLangValue(460000);
		end
	elseif showVo.is_have == 1 then
		self.shareBtn:setLangValue(460001);
	end
	local isHaveAndNoDraw = showVo.is_active == 1 and showVo.is_draw_active_reward == 0;
	self.rewardObj:SetActive(isHaveAndNoDraw and self.isShowBtn);
	self.shareBtn:setEnable(self.isShowBtn);
	self:showRedDot(isHaveAndNoDraw and self.isShowBtn);
	self:updatePropertyInfo(showVo);
end

function Lua_CollectionDetailWindow:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.rewardObj);
			self.redPoint:setLocation(25, 25, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CollectionDetailWindow:updatePropertyInfo(collectionVo)
	self.itemIcon:setData(collectionVo);
	self.itemNameTxt.text = collectionVo.name;

	self.detailPanel:setData(self.showData);
	
	local showHeight = self.containerStartPosY - self.detailPanel:getHeight();
	if type(self.showData) == "table" then -- 聊天场景和道具tips
		self.getTimeTxt:setLangValue(460016);
		self.timeTxt.text = collectionVo.effect_des;
		self.winBg:SetDimensions(434, self.startPosY - showHeight + 30);
	else -- 藏品柜查看
		self.getTimeTxt:setLangValue(460015);
		self.shareBtn:setLocation(0, showHeight - 45);
		self.winBg:SetDimensions(434, self.startPosY - self.shareBtn.posY + 60);
		if collectionVo.is_have == 0 then -- 未拥有
			self.timeTxt:setLangValue(460002);
		else
			self.timeTxt.text = os.date("%Y/%m/%d", collectionVo.get_tick);
		end
	end
	local posY = Mathf.Abs(self.winBg.posY - self.winBg.height / 2);
	LuaUtil.setObjPos(self.content, 0, posY, 0);
end

function Lua_CollectionDetailWindow:onBtnClick(go)
	Lua_ProxyManager.getProxy("Lua_CollectionProxy"):sReceiveCollection(self.showData);
end

function Lua_CollectionDetailWindow:onShareClick(go)
	local collectionVo = DataCenter.collectionData:getCollectionVo(self.showData);
	if collectionVo.is_have == 0 then
		local targetValue = getConfig(collectionVo.target_value[1], collectionVo.target_value[2], collectionVo.target_value[3]);
		local progressValue = collectionVo.obtain_progress;
		if progressValue >= targetValue then
			if collectionVo.complete_path_id then
				DataCenter.funcPathUtil:gotoFunction(collectionVo.complete_path_id, true);
			end
		else
			if collectionVo.func_open_id and not DataCenter.funcOpenData:isOpened(collectionVo.func_open_id, true) then
				-- OperateAlert.showLangValue(460003);
				return;
			end
			if collectionVo.func_path_id then
				DataCenter.funcPathUtil:gotoFunction(collectionVo.func_path_id, true);
			end
		end
	elseif collectionVo.is_have == 1 then
		local posY = Mathf.Abs(self.winBg.posY - self.winBg.height / 2);
		local param = {id = self.showData, posX = self.shareBtn.posX, posY = self.shareBtn.posY + posY};
		Lua_WindowUtil.openWin("Lua_CollectionShareWindow", Lua_WinParam.ACTION_OPEN, param);
	end
end

function Lua_CollectionDetailWindow:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.showCollectVo = nil;

	self:superCall("dispose");
end