-- 藏品柜成长词条进度Tips
Lua_CollectionPopupWindow = class("Lua_CollectionPopupWindow", Lua_Window);
function Lua_CollectionPopupWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionPopupWindow";
	self.skinName = "CollectionPopupWindow_skin";
	self.isFullSizeWin = true;
end

function Lua_CollectionPopupWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.winBg:addClickFuntion(self, self.onJumpClick);
end

function Lua_CollectionPopupWindow:showWin(param)
	self:superCall("showWin", param);

	local collectVo = DataCenter.collectionData:getCollectionVo(param);
	self.itemIcon:setAltas(collectVo.atlas, collectVo.sprite);
	self.itemNameTxt.text = collectVo.name;

	-- 策划要求：只显示1条
	local changeProgress = collectVo.change_progress or 1;
	self.completeTxt.text = LanUtil.formateStr(collectVo.configArr[1].popup_desc, changeProgress * collectVo.configArr[1].each);

	local attrVo;
	local curAttrStr = "";
	-- for i = 1, collectVo.configArr:getSize() do
		for k,v in pairs(collectVo.configArr[1].prop) do
			attrVo = DataCenter.attributesUtil:createAttrVo(k);
			attrVo.value = v * changeProgress;
			curAttrStr = curAttrStr .. " " .. attrVo.show_name .. "+" .. attrVo.showValue;
		end
	-- end
	self.upTxt.text = curAttrStr;

	local info = getConfig("total_task", collectVo.configArr[1].grow_cond_id);
	local targetValue = info.client_condition == nil and info.progress or getConfig(info.client_condition[1], info.progress, info.client_condition[2]);
	targetValue = targetValue / collectVo.configArr[1].each;
	self.progressBar:setMaxValue(targetValue);
	self.progressBar:setValue(collectVo.grow_progress);
	self.progressBar:setText(collectVo.grow_progress .. "/" .. targetValue);

	self.time = 2;
	Lua_CommonUtil.addTimer("onCountDown", 1, self, self.onCountDown);
	self:onCountDown();
end

function Lua_CollectionPopupWindow:onCountDown()
	self.time = self.time - 1;
	if self.time < 0 then
		Lua_CommonUtil.removeTimer(self, self.onCountDown);
		Lua_WindowUtil.openWin(self.windowName, Lua_WinParam.ACTION_CLOSE);
		DataCenter.collectionData:checkPopupInfo();
	end
end

function Lua_CollectionPopupWindow:onJumpClick(go)
	if not Lua_WindowUtil.isWindowShowing("Lua_CollectionWindow") then
		Lua_WindowUtil.openWin("Lua_CollectionWindow");
	end
	Lua_WindowUtil.openWin("Lua_CollectionDetailWindow", Lua_WinParam.ACTION_OPEN, self.showData);
	Lua_WindowUtil.openWin(self.windowName, Lua_WinParam.ACTION_CLOSE);
	DataCenter.collectionData:checkPopupInfo();
end

function Lua_CollectionPopupWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.onCountDown);
	self:superCall("dispose");
end