Lua_CollectionShareWindow = class("Lua_CollectionShareWindow", Lua_Window);
function Lua_CollectionShareWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionShareWindow";
	self.skinName = "CollectionShareWindow_skin";
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.blackAlpha = 0.1;
end

function Lua_CollectionShareWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.worldBtn:addClickFuntion(self, self.onShareWorldClick);
	self.serverBtn:addClickFuntion(self, self.onShareLeagueClick);
end

function Lua_CollectionShareWindow:showWin(param)
	self:superCall("showWin", param);

	LuaUtil.setObjPos(self.shareObj, 0, param.posY, 0);
	TweenUtil.getInstance():addTweenTargetPos(self.shareObj, 1, 0, 0, param.posY + 77.5, 0, 0, false);
end

function Lua_CollectionShareWindow:onShareWorldClick()
	local info = DataCenter.collectionData:getCollectionVo(self.showData.id);
	-- local limitTimes = getConfig("collection_cabinet_const", "collection_shared_daily_limit", "value");
	if info.is_share == 1 then
		OperateAlert.showLangValue(460009);
		return;
	end

	local str = LanUtil.formateStr(460010, info.name);
	DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTION, self.showData.id);
	Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_WORLD, str, false, true);
	-- print("分享到世界频道", info.id, str);
end

function Lua_CollectionShareWindow:onShareLeagueClick()
	local info = DataCenter.collectionData:getCollectionVo(self.showData.id);
	-- local limitTimes = getConfig("collection_cabinet_const", "collection_shared_daily_limit", "value");
	if info.is_share == 1 then
		OperateAlert.showLangValue(460009);
		return;
	end

	if DataCenter.funcOpenData:isOpened(10229) and DataCenter.roleData.league_id > 0 then
		local info = DataCenter.collectionData:getCollectionVo(self.showData.id);
		local str = LanUtil.formateStr(460010, info.name);
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTION, self.showData.id);
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_LEAGUE, str, false, true);
		-- print("分享到社团频道", info.id, str);
	else
		OperateAlert.showLangValue(460011);
	end
end

function Lua_CollectionShareWindow:dispose()
	TweenUtil.getInstance():stop(self.shareObj);

	self:superCall("dispose");
end